--Specjalizacja dla Kosiarka rotacyjna--
--Autor: Rockstar94--
--Data: 22.08.2014--



Kosiarka = {};

function Kosiarka.prerequisitesPresent(specializations)
return true;
end;

function Kosiarka:load(xmlFile)
	local rozkladanie_kosiarka = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rozkladanie_kosiarka#index"));
	if rozkladanie_kosiarka ~= nil then
		self.rozkladanie_kosiarka = rozkladanie_kosiarka;
	end;
		
	local stopka_kosiarka = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.stopka_kosiarka#index"));
	if stopka_kosiarka ~= nil then
		self.stopka_kosiarka = stopka_kosiarka;
	end;
	
	local plandeka_kosiarka = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.plandeka_kosiarka#index"));
	if plandeka_kosiarka ~= nil then
		self.plandeka_kosiarka = plandeka_kosiarka;
	end;
end;

function Kosiarka:delete()
end;

function Kosiarka:keyEvent(unicode, sym, modifier, isDown)
 end;
 
function Kosiarka:update(dt)	
    local nearestDistance = 2.5;
    local vx, vy, vz = getWorldTranslation(g_currentMission.player.rootNode);
    local px, py, pz = getWorldTranslation(self.rozkladanie_kosiarka);
    local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
		if distance < nearestDistance then
			self.przyrozkladanie_kosiarka = true;
		else
			self.przyrozkladanie_kosiarka = false;
		end;
		
    if self.przyrozkladanie_kosiarka then
		if InputBinding.hasEvent(InputBinding.rozkladanie_kosiarka) then
			if self.animationParts[1].clipEndTime then
				self:setAnimationTime(1, self.animationParts[1].offSet);
			elseif self.animationParts[1].clipStartTime  then
				self:setAnimationTime(1, self.animationParts[1].animDuration);	
			end;
		end;
    end;
	
	if not self.isTurnedOn then	
		if self.przyrozkladanie_kosiarka then
			if self.animationParts[1].clipStartTime then
				g_currentMission:addHelpButtonText(string.format(g_i18n:getText("Rozloz_kos")), InputBinding.rozkladanie_kosiarka);
			else
				g_currentMission:addHelpButtonText(string.format(g_i18n:getText("Zloz_kos")), InputBinding.rozkladanie_kosiarka);
			end;
		end;
	end;
	
	if self.isTurnedOn then
        self:setAnimationTime(2, 1);
    else
        self:setAnimationTime(2, 0);
    end;	
	
	local nearestDistance = 2;
    local vx, vy, vz = getWorldTranslation(g_currentMission.player.rootNode);
    local px, py, pz = getWorldTranslation(self.stopka_kosiarka);
    local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
	if distance < nearestDistance then
		self.przystopka_kosiarka = true;
	else
		self.przystopka_kosiarka = false;
    end;
	
    if self.przystopka_kosiarka then
		if InputBinding.hasEvent(InputBinding.stopka_kosiarka) then
			if self.animationParts[3].clipEndTime then
				self:setAnimationTime(3, self.animationParts[3].offSet);
			elseif self.animationParts[3].clipStartTime then
				self:setAnimationTime(3, self.animationParts[3].animDuration);
			end;
		end;
    end;
	
	if self.przystopka_kosiarka then
		if self.animationParts[3].clipStartTime then
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("Podnies_kos")), InputBinding.stopka_kosiarka);
		else
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("Opusc_kos")), InputBinding.stopka_kosiarka);
		end;
	end;
	
	if self.animationParts[3].clipStartTime and self:getIsActive(false) then
		g_currentMission:addWarning(g_i18n:getText("info_kos"), 0.07+0.022, 0.019+0.029);
	end;
	
	if self.animationParts[1].clipStartTime and self:getIsActive(false) and Input.isKeyPressed(Input.KEY_b) then
		g_currentMission:addWarning(g_i18n:getText("info1_kos"), 0.07+0.022, 0.019+0.029);
	end;

	if self.animationParts[1].clipStartTime then
		self.mowerStartSoundVolume = 0
	end;
	
	if self.animationParts[1].clipEndTime then
		self.mowerStartSoundVolume = 0.6
	end;
	
	if self.animationParts[1].clipStartTime then
		self.isTurnedOn = false;
	end;
	
	local nearestDistance = 2;
    local vx, vy, vz = getWorldTranslation(g_currentMission.player.rootNode);
    local px, py, pz = getWorldTranslation(self.plandeka_kosiarka);
    local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
	if distance < nearestDistance then
		self.przyplandeka_kosiarka = true;
	else
		self.przyplandeka_kosiarka = false;
    end;
	
	if self.animationParts[5].clipStartTime then
		if self.przyplandeka_kosiarka then
			if InputBinding.hasEvent(InputBinding.plandeka_kosiarka) then
				if self.animationParts[4].clipEndTime then
					self:setAnimationTime(4, self.animationParts[4].offSet);
				elseif self.animationParts[4].clipStartTime then
					self:setAnimationTime(4, self.animationParts[4].animDuration);
				end;
			end;
		end;
	end

	if self.animationParts[5].clipStartTime then
		if not self.isTurnedOn then
			if self.przyplandeka_kosiarka then
				if self.animationParts[4].clipStartTime then
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("Zdejmij_kos")), InputBinding.plandeka_kosiarka);
				else
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("Zaloz_kos")), InputBinding.plandeka_kosiarka);
				end;
			end;
		end;
	end;

	if self.animationParts[4].clipEndTime then
		if self.przyplandeka_kosiarka then
			if InputBinding.hasEvent(InputBinding.oslona_kosiarka) then
				if self.animationParts[5].clipEndTime then
					self:setAnimationTime(5, self.animationParts[5].offSet);
				elseif self.animationParts[5].clipStartTime then
					self:setAnimationTime(5, self.animationParts[5].animDuration);
				end;
			end;
		end;
	end;
	
	if self.animationParts[4].clipEndTime then
		if not self.isTurnedOn then
			if self.przyplandeka_kosiarka then
				if self.animationParts[5].clipStartTime then
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("Zdejmij_os_kos")), InputBinding.oslona_kosiarka);
				else
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("Zaloz_os_kos")), InputBinding.oslona_kosiarka);
				end;
			end;
		end;
	end;
end;

function Kosiarka:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Kosiarka:validateAttacherJoint(implement, jointDesc, dt)
return true;
end;

function Kosiarka:draw()
end;